from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from .com.sun.star.uno import XInterface

@runtime_checkable
class XTextLayout(XInterface, Protocol):
    def queryTextShapes(self) -> list[XPolyPolygon2D]: ...
    def queryInkMeasures(self) -> list[RealRectangle2D]: ...
    def queryMeasures(self) -> list[RealRectangle2D]: ...
    def queryLogicalAdvancements(self) -> list[float]: ...
    def queryKashidaPositions(self) -> list[bool]: ...
    def queryTextBounds(self) -> RealRectangle2D: ...
    def getTextHit(self, aHitPoint: RealPoint2D) -> TextHit: ...
    def getBaselineOffset(self) -> float: ...
    def getMainTextDirection(self) -> int: ...
    def getFont(self) -> XCanvasFont: ...
    def getText(self) -> StringContext: ...
